<?php
/**
 * Pagination display provider
 *
 * This template can be overridden by copying it to yourtheme/eventful-pro-por-elementor/templates/pagination.php
 *
 * @package    Eventful_pro_for_elementor
 * @subpackage Eventful_pro_for_elementor/public
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

$efpe_settings       = isset($_POST['efpe_settings']) ? $_POST['efpe_settings'] : '';
$post_per_page       = isset($_POST['post_per_page']) ? $_POST['post_per_page'] : '';
$efpe_post_limit     = isset($_POST['efpe_post_limit']) ? $_POST['efpe_post_limit'] : '';

if ( $show_pagination && ! $efpe_query->is_main_query() ) {
	// Paged argument.
	if ( get_query_var( 'paged' ) ) {
		$efpe_paged = get_query_var( 'paged' );
	} elseif ( get_query_var( 'page' ) ) {
		$efpe_paged = get_query_var( 'page' );
	} else {
		$efpe_paged = 1;
	}
	$load_more_text    = isset( $efpe_settings['load_more_text'] ) ? $efpe_settings['load_more_text'] : $view_options['load_more_text'];
	$pagination_message = isset( $efpe_settings['pagination_message'] ) ? $efpe_settings['pagination_message'] : $view_options['pagination_message'];
	?>
	<span class="ta-efpe-pagination-data"  data-loadmoretext="<?php echo esc_attr( $load_more_text ); ?>" data-endingtext="<?php echo esc_attr( $pagination_message ); ?>"></span>

		<nav class="efpe-post-pagination efpe-on-desktop <?php echo esc_attr( $pagination_type ); ?>">
		<?php
			EFPE_HTML::efpe_pagination_bar( $efpe_query, $view_options, $layout_preset, $efpe_gl_id, $efpe_settings, $post_per_page, $efpe_post_limit ); 
		?>
		</nav>
	<?php
}
?>
