<?php

namespace Elementor;

use Elementor\Widget_Base;
use Elementor\Core\Kits\Documents\Tabs\Global_Colors;
use Elementor\Core\Kits\Documents\Tabs\Global_Typography;

class Eventful_Pro_Post_Grid_Widget extends Widget_Base
{

    public function get_name()
    {
        return 'eventful-post-grid-widget';
    }

    public function get_title()
    {
        return esc_html__('Eventful Grid', 'eventful-pro-for-elementor');
    }

    public function get_style_depends()
    {
        return [
            'fontawesome',
            'eventful-main',
        ];
    }
    public function get_script_depends()
    {
        return [
            'grid_scripts',
            'efpe-likes-public',
        ];
    }


    public function get_icon()
    {
        return 'eicon-posts-grid';
    }

    public function get_categories()
    {
        return ['ppfe-for-elementor'];
    }

    public function _register_controls()
    {
        // Include control files
        require_once(__DIR__ . '/options/class-efpe-utlities-functions.php');
        require_once(__DIR__ . '/options/class-efpe-layout-options.php');
        require_once(__DIR__ . '/options/class-efpe-contents-options.php');
        require_once(__DIR__ . '/options/class-efpe-pagination.php');
        require_once(__DIR__ . '/options/class-efpe-query-options.php');
        require_once(__DIR__ . '/options/class-efpe-detailssettings.php');
        require_once(__DIR__ . '/options/class-efpe-style-layout-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-box-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-category-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-image-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-title-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-meta-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-event-meta-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-content-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-readmore-options.php');
        require_once(__DIR__ . '/options/class-efpe-style-social-share.php');
        require_once(__DIR__ . '/options/class-efpe-style-pagination.php');
        require_once(__DIR__ . '/options/class-efpe-style-filter-bar.php');
        // Register text control
        \EFPE_Layout::ppfe_content_layout_options($this);
        \EFPE_Contents::ppfe_content_contents_options($this);
        \EFPE_Pagination::ppfe_content_pagination_options($this);
        \EFPE_Query::ppfe_content_query_options($this);
        \EFPE_Detailsettings::ppfe_content_detailsettings_options($this);
        \EFPE_Query_Style_Layout::ppfe_style_layout_options($this);
        \EFPE_Query_Style_Box::ppfe_style_box_options($this);
        \EFPE_Query_Style_Category::ppfe_style_category_options($this);
        \EFPE_Query_Style_Image::ppfe_style_image_options($this);
        \EFPE_Query_Style_Title::ppfe_style_title_options($this);
        \EFPE_Query_Style_Meta::ppfe_style_meta_options($this);
        \EFPE_Query_Style_Event_Meta::ppfe_style_event_meta_options($this);
        \EFPE_Query_Style_Content::ppfe_style_content_options($this);
        \EFPE_Query_Style_Readmore::ppfe_style_readmore_options($this);
        \EFPE_Query_Style_Social_Share::ppfe_style_social_share($this);
        \EFPE_Query_Style_Pagination::ppfe_style_pagination($this);
        \EFPE_Query_Style_Filter_Bar::ppfe_style_filter_bar($this);
    }

    protected function render()
    {
        $view_options = $this->get_settings_for_display();
        $efpe_gl_id = $this->get_id();
        \EFPE_HTML::efpe_html_show($view_options, $layout_preset = 'grid_layout', $efpe_gl_id);
    }
}

Plugin::instance()->widgets_manager->register_widget_type(new Eventful_Pro_Post_Grid_Widget());
