<?php

class EFPE_Contents
{
    /**
     * Content Contents Options.
     */
    public static function ppfe_content_contents_options($widget)
    {
        $widget->start_controls_section(
            'section_contents',
            [
                'label' => esc_html__('Contents', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
            'show_image',
            [
                'label'         => esc_html__('Image', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default'       => 'yes',
                'separator'     => 'before',
            ]
        );

        $widget->add_group_control(
            \Elementor\Group_Control_Image_Size::get_type(),
            [
                'name'          => 'post_thumbnail',
                'default'       => 'full',
                'prefix_class'  => 'post-thumbnail-size-',
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'load_2x_image',
            [
                'label'         => esc_html__('Load 2x Resolution Image in Retina Display', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'thumb_src_replace',
            [
                'label'         => esc_html__('Replace With', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'multiple'      => true,
                'options'       => [
                    'image'     => esc_html__('Image', 'eventful-pro-for-elementor'),
                    'video'     => esc_html__('Video', 'eventful-pro-for-elementor'),
                    'audio'     => esc_html__('Audio', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'none',
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'thumb_zoom',
            [
                'label'         => esc_html__('Zoom Effect', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'none'      => esc_html__('None', 'eventful-pro-for-elementor'),
                    'zoom_in'   => esc_html__('Zoom In', 'eventful-pro-for-elementor'),
                    'zoom_out'  => esc_html__('Zoom Out', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'none',
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'thumb_gray_scale',
            [
                'label'         => esc_html__('Image Mode', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'none'      => esc_html__('Normal', 'eventful-pro-for-elementor'),
                    'gray_and_normal'   => esc_html__('Grayscale and normal on hover', 'eventful-pro-for-elementor'),
                    'gray_on_hover'     => esc_html__('Grayscale on hover', 'eventful-pro-for-elementor'),
                    'always_gray'       => esc_html__('Always grayscale', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'none',
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'thumb_lazy_load',
            [
                'label'         => esc_html__('Lazy Load', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default'       => 'yes',
            ]
        );

        $widget->add_control(
            'thumb_meta',
            [
                'label'         => esc_html__('Show Thumb Meta', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'category'  => esc_html__('Category', 'eventful-pro-for-elementor'),
                    'date'      => esc_html__('Date', 'eventful-pro-for-elementor'),
                    'none'      => esc_html__('None', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'none',
                'condition'     => [
                    'show_image' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'thumb_meta_taxonomy',
            [
                'label'         => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => array_merge(['' => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor')], EFPE_Utilities_Functions::get_post_type_taxonomies('tribe_events')),
                'condition'     => [
                    'show_image' => 'yes',
                    'thumb_meta' => 'category',
                ],
            ]
        );

        $widget->add_control(
            'thumb_meta_date_format',
            [
                'label'         => esc_html__('Date Format', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'default'   => esc_html__('Default', 'eventful-pro-for-elementor'),
                    'time_ago'  => esc_html__('Time ago(human time)', 'eventful-pro-for-elementor'),
                    'custom'    => esc_html__('Custom', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'default',
                'condition'     => [
                    'show_image' => 'yes',
                    'thumb_meta' => 'date',
                ],
            ]
        );

        $widget->add_control(
            'custom_date_format',
            [
                'label'         => esc_html__('Custom Format ', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::TEXT,
                'placeholder'   => esc_html__('F j, Y', 'eventful-pro-for-elementor'),
                'description'   => esc_html__('To define format, check <a href="https://wordpress.org/support/article/formatting-date-and-time/" target="_blank" rel="noopener noreferrer nofollow"><em>this doc</em></a>.', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'show_image' => 'yes',
                    'thumb_meta' => 'date',
                    'thumb_meta_date_format' => 'custom',
                ],
            ]
        );

        $widget->add_control(
            'thumb_meta_position',
            [
                'label' => esc_html__('Taxonomy Position', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'top_right'         => esc_html__('Top right', 'eventful-pro-for-elementor'),
                    'top_center'        => esc_html__('Top center', 'eventful-pro-for-elementor'),
                    'top_left'          => esc_html__('Top left', 'eventful-pro-for-elementor'),
                    'bottom_left'       => esc_html__('Bottom left', 'eventful-pro-for-elementor'),
                    'bottom_center'     => esc_html__('Bottom center', 'eventful-pro-for-elementor'),
                    'bottom_right'      => esc_html__('Bottom right', 'eventful-pro-for-elementor'),
                ],
                'default'   => 'top_right',
                'condition' => [
                    'show_image' => 'yes',
                    'thumb_meta!' => 'none',
                ],
            ]
        );

        $widget->add_control(
            'show_title',
            [
                'label'         => esc_html__('Title', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default'       => 'yes',
                'separator'     => 'before',
            ]
        );

        $widget->add_control(
            'title_tag',
            [
                'label' => esc_html__('Title HTML Tag', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'h1' => 'H1',
                    'h2' => 'H2',
                    'h3' => 'H3',
                    'h4' => 'H4',
                    'h5' => 'H5',
                    'h6' => 'H6',
                    'div' => 'div',
                    'span' => 'span',
                    'p' => 'p',
                ],
                'default' => 'h3',
                'condition' => [
                    'show_title' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'title_limit',
            [
                'label' => esc_html__('Limit Character', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );
        $widget->add_control(
            'title_length',
            [
                'label' => esc_html__('Length', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::NUMBER,
                'default' => '30',
                'condition' => [
                    'title_limit' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'title_alignment',
            [
                'label' => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .eventful__item .eventful__item--title' => 'text-align: {{VALUE}};',
                ],
                'condition' => [
                    'show_title' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'show_meta',
            [
                'label' => esc_html__('Meta Fields', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
                'separator' => 'before',
            ]
        );

        $widget->add_control(
            'meta_data',
            [
                'label' => esc_html__('Meta Data', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'multiple' => true,
                'label_block' => true,
                'options' => [
                    'author' => esc_html__('Author', 'eventful-pro-for-elementor'),
                    'date' => esc_html__('Date', 'eventful-pro-for-elementor'),
                    'categories' => esc_html__('Categories', 'eventful-pro-for-elementor'),
                    'comments' => esc_html__('Comments', 'eventful-pro-for-elementor'),
                    'like' => esc_html__('Like', 'eventful-pro-for-elementor'),
                    'reading_time' => esc_html__('Reading Time', 'eventful-pro-for-elementor'),
                ],
                'default' => ['author', 'date', 'comments'],
                'condition' => [
                    'show_meta' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'author_toggle',
            [
                'label' => esc_html__('Author', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data' => 'author',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'meta_author_avatar',
            [
                'label' => esc_html__('Avatar', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'show_name' => esc_html__('Show name', 'eventful-pro-for-elementor'),
                    'show_gravatar' => esc_html__('Show gravatar', 'eventful-pro-for-elementor'),
                    'name_with_gravatar' => esc_html__('Author name & gravatar', 'eventful-pro-for-elementor'),
                    'name_with_icon' => esc_html__('Author name with an icon', 'eventful-pro-for-elementor'),
                ],
                'default' => 'name_with_icon',
            ]
        );
        $widget->add_control(
            'author_icon',
            [
                'label' => esc_html__('Author Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-user',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'user',
                        'user-alt',
                        'user-circle',
                    ],
                    'fa-regular' => [
                        'user',
                        'user-alt',
                        'user-circle',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'date_toggle',
            [
                'label' => esc_html__('Date', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data' => 'date',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'meta_date_format',
            [
                'label' => esc_html__('Date Format', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'default' => esc_html__('Default', 'eventful-pro-for-elementor'),
                    'time_ago' => esc_html__('Time ago(human time)', 'eventful-pro-for-elementor'),
                    'custom' => esc_html__('Custom', 'eventful-pro-for-elementor'),
                ],
                'default' => 'default',
            ]
        );
        $widget->add_control(
            'meta_custom_date_format',
            [
                'label' => esc_html__('Custom Format ', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'placeholder'   => esc_html__('F j, Y', 'eventful-pro-for-elementor'),
                'description' => esc_html__('To define format, check <a href="https://wordpress.org/support/article/formatting-date-and-time/" target="_blank" rel="noopener noreferrer nofollow"><em>this doc</em></a>.', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'meta_date_format' => 'custom',
                ],
            ]
        );
        $widget->add_control(
            'date_icon',
            [
                'label' => esc_html__('Date Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-clock',
                    'library' => 'fa-regular',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'clock',
                    ],
                    'fa-regular' => [
                        'clock',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'taxonomy',
            [
                'label' => esc_html__('Taxonomy', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data' => 'categories',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'meta_categories',
            [
                'label'         => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => array_merge(['' => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor')], EFPE_Utilities_Functions::get_post_type_taxonomies('tribe_events')),
            ]
        );

        $widget->add_control(
            'categories_icon',
            [
                'label' => esc_html__('Taxonomy Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-tag',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'tag',
                        'tags',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'comments_toggle',
            [
                'label' => esc_html__('Comments', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data' => 'comments',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'comments_icon',
            [
                'label' => esc_html__('Comments Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-comment-alt',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'comment',
                        'comment-alt',
                        'comments',
                    ],
                    'fa-regular' => [
                        'comment',
                        'comment-alt',
                        'comments',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'reading_time_toggle',
            [
                'label' => esc_html__('Reading Time', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data' => 'reading_time',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'word_per_minute',
            [
                'label' => esc_html__('Word Per Minute', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::NUMBER,
                /** This filter is documented in wp-includes/formatting.php */
                'default' => apply_filters('excerpt_length', 25),
            ]
        );

        $widget->add_control(
            'reading_time_icon',
            [
                'label' => esc_html__('Reading Time Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-book-reader',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'book-reader',
                    ],
                ],
            ]
        );

        $widget->add_control(
            'reading_time_postfix',
            [
                'label' => esc_html__('Reading Time Postfix', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'default' => esc_html__(' Min Read', 'eventful-pro-for-elementor'),
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'meta_separator',
            [
                'label' => esc_html__('Separator Between', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'selectors' => [
                    '{{WRAPPER}} .eventful__item .eventful__item__content--meta ul li:not(:last-child):after' => 'content: "{{VALUE}}"',
                ],
                'condition' => [
                    'show_meta' => 'yes',
                    'meta_data!' => [],
                ],
            ]
        );

        $widget->add_control(
            'meta_alignment',
            [
                'label' => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .eventful__item .eventful__item--meta ul' => 'justify-content: {{VALUE}};',
                ],
                'condition' => [
                    'show_meta' => 'yes',
                ],
            ]
        );
        //********************************************************** */
        $widget->add_control(
            'show_event_meta',
            [
                'label' => esc_html__('Event Meta Fields', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
                'separator' => 'before',
            ]
        );

        $widget->add_control(
            'event_meta_data',
            [
                'label' => esc_html__('Event Meta Data', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'multiple' => true,
                'label_block' => true,
                'options' => [
                    'venue' => esc_html__('Venue', 'eventful-pro-for-elementor'),
                    'organizer' => esc_html__('Organizer', 'eventful-pro-for-elementor'),
                    'price' => esc_html__('Price', 'eventful-pro-for-elementor'),
                    'event_time' => esc_html__('Event Time', 'eventful-pro-for-elementor'),
                ],
                'default' => ['venue', 'organizer', 'price'],
                'condition' => [
                    'show_event_meta' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'venue_toggle',
            [
                'label' => esc_html__('Venue', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'venue',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'venue_settings',
            [
                'label' => esc_html__('Venue Settings', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'label_block' => true,
				'multiple' => true,
                'options'  => array(
                    'address' => esc_html__('Address', 'eventful-pro-for-elementor'),
                    'city' => esc_html__('City', 'eventful-pro-for-elementor'),
                    'country' => esc_html__('Country', 'eventful-pro-for-elementor'),
                    'state' => esc_html__('State', 'eventful-pro-for-elementor'),
                    'postal_code' => esc_html__('Postal Code', 'eventful-pro-for-elementor'),
                    'phone' => esc_html__('Phone', 'eventful-pro-for-elementor'),
                ),
                'default' => array('address'),
            ]
        );
        $widget->add_control(
            'venue_map_link',
            [
                'label' => esc_html__('Show Map Link', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
            ]
        );
        $widget->add_control(
            'event_venue_icon',
            [
                'label' => esc_html__('Meta Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-map-marker-alt',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'map-marker-alt',
                        'map-marker',
                        'map-marked-alt',
                        'blender-phone',
                        'phone-alt',
                        'phone',
                    ],
                    'fa-regular' => [
                        'map-marker-alt',
                        'map-marker',
                        'map-marked-alt',
                        'blender-phone',
                        'phone-alt',
                        'phone',
                    ],
                ],
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'venue',
                ],
            ]
        );
        $widget->add_control(
            'venue_phone_icon',
            [
                'label' => esc_html__('Meta Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-phone-alt',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'blender-phone',
                        'phone-alt',
                        'phone',
                    ],
                    'fa-regular' => [
                        'blender-phone',
                        'phone-alt',
                        'phone',
                    ],
                ],
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'venue',
                    'venue_settings' => 'phone',
                ],
            ]
        );
        
        $widget->end_popover();

        $widget->add_control(
            'organizer_toggle',
            [
                'label' => esc_html__('Organizer', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'organizer',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'event_organizer_icon',
            [
                'label' => esc_html__('Date Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-user',
                    'library' => 'fa-regular',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'user',
                        'fa-user',
                    ],
                    'fa-regular' => [
                        'user',
                        'fa-user',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'event_price_toggle',
            [
                'label' => esc_html__('Price', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'price',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'event_price_icon',
            [
                'label' => esc_html__('Date Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'fas fa-dollar-sign',
                    'library' => 'fa-solid',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'dollar-sign',
                    ],
                ],
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'event_time_toggle',
            [
                'label' => esc_html__('Event Time', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'show_event_meta' => 'yes',
                    'event_meta_data' => 'event_time',
                ],
            ]
        );

        $widget->start_popover();
        $widget->add_control(
            'event_date_icon',
            [
                'label' => esc_html__('Event Icon', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::ICONS,
                'default' => [
                    'value' => 'far fa-clock',
                    'library' => 'fa-clock',
                ],
                'recommended' => [
                    'fa-solid' => [
                        'clock',
                    ],
                    'fa-regular' => [
                        'clock',
                    ],
                ],
            ]
        );

        $widget->add_control(
            'event_fildes_date_type',
            [
                'label' => esc_html__('Date Type', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => array(
                    'start_date' => esc_html__('Start Date and Time', 'eventful-pro-for-elementor'),
                    'end_date' => esc_html__('End Date and Time', 'eventful-pro-for-elementor'),
                    'start_date_time_with_end_date_time' => esc_html__('Start Date Time With End Date Time', 'eventful-pro-for-elementor'),
                ),
                'default' => 'start_date',
            ]
        );

        $widget->add_control(
            'event_fildes_date_format',
            [
                'label' => esc_html__('', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => array(
                    'j F, Y g:i A' => esc_html__('Default (01 January 2024 12:00 AM)', 'eventful-pro-for-elementor'),
                    'F j, Y g:i A' => esc_html__('Default (January 01 2024 12:00 AM)', 'eventful-pro-for-elementor'),
                    'F j, g:i A' => esc_html__('Default (January 01 12:00 AM)', 'eventful-pro-for-elementor'),
                    'j F, g:i A' => esc_html__('Default ( 01 January 12:00 AM)', 'eventful-pro-for-elementor'),
                    'j M, g:i A' => esc_html__('Default ( 01 Jan 12:00 AM)', 'eventful-pro-for-elementor'),
                    'M j, g:i A' => esc_html__('Default ( Jan 01 12:00 AM)', 'eventful-pro-for-elementor'),
                    'j F, Y' => esc_html__('Default (01 January 2024)', 'eventful-pro-for-elementor'),
                    'F j, Y' => esc_html__('Default (January 01 2024)', 'eventful-pro-for-elementor'),
                    'j F, Y' => esc_html__('Default (01 January 2024)', 'eventful-pro-for-elementor'),
                    'M j, Y' => esc_html__('Default (Jan 01 2024)', 'eventful-pro-for-elementor'),
                    'j M, Y' => esc_html__('Default (01 Jan 2024)', 'eventful-pro-for-elementor'),
                    'g:i A' => esc_html__('Default (12:50 AM)', 'eventful-pro-for-elementor'),
                    'G:i' => esc_html__('Default (23:00)', 'eventful-pro-for-elementor'),
                    'custom' => esc_html__('Custom', 'eventful-pro-for-elementor'),
                ),
                'default' => 'j F, Y g:i A',
                'description' => __('To define format, check <a href="https://wordpress.org/support/article/formatting-date-and-time/" target="_blank" rel="noopener noreferrer nofollow"><em>this doc</em></a>.', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
            'efpe_custom_event_date_format',
            [
                'label' => esc_html__('', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'placeholder' => esc_html__('j F, Y g:i A', 'eventful-pro-for-elementor'),
                'condition' => [
                    'event_fildes_date_format' => 'custom',
                ],
                'description' => __('To define format, check <a href="https://wordpress.org/support/article/formatting-date-and-time/" target="_blank" rel="noopener noreferrer nofollow"><em>this doc</em></a>.', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->end_popover();


        $widget->add_control(
            'event_meta_separator',
            [
                'label' => esc_html__('Separator Between', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'condition' => [
                    'show_event_meta' => 'yes',
                    'meta_data!' => [],
                ],
            ]
        );

        $widget->add_control(
            'event_meta_alignment',
            [
                'label' => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .eventful__item .eventful__item--meta.event_meta ul' => 'justify-content: {{VALUE}};',
                ],
                'condition' => [
                    'show_event_meta' => 'yes',
                ],
            ]
        );
        //********************************************************** */
        $widget->add_control(
            'show_content',
            [
                'label' => esc_html__('Content', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
                'separator' => 'before',
            ]
        );

        $widget->add_control(
            'content_type',
            [
                'label' => esc_html__('Content Display Type', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'excerpt'  => esc_html__('Excerpt', 'eventful-pro-for-elementor'),
                    'limit_content' => esc_html__('Content with Limit', 'eventful-pro-for-elementor'),
                    'full_content' => esc_html__('Full Content', 'eventful-pro-for-elementor'),
                ],
                'default' => 'limit_content',
                'condition' => [
                    'show_content' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'content_length_type',
            [
                'label' => esc_html__('Content Length Type', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'words'  => esc_html__('Words', 'eventful-pro-for-elementor'),
                    'characters' => esc_html__('Characters', 'eventful-pro-for-elementor'),
                ],
                'default' => 'words',
                'condition' => [
                    'show_content' => 'yes',
                    'content_type' => 'limit_content',
                ],
            ]
        );
        $widget->add_control(
            'content_limit',
            [
                'label'     => esc_html__('Words Length', 'eventful-pro-for-elementor'),
                'type'      => \Elementor\Controls_Manager::NUMBER,
                'default'   => '30',
                'max'       => '1000',
                'condition' => [
                    'show_content' => 'yes',
                    'content_type' => 'limit_content',
                    'content_length_type' => 'words',
                ],
            ]
        );

        $widget->add_control(
            'content_characters_limit',
            [
                'label' => esc_html__('Characters Length', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::NUMBER,
                'default' => '30',
                'max' => '1000',
                'condition' => [
                    'show_content' => 'yes',
                    'content_type' => 'limit_content',
                    'content_length_type' => 'characters',
                ],
            ]
        );

        $widget->add_control(
            'strip_tags',
            [
                'label' => esc_html__('HTML Tags', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'default' => 'limit_content',
                'options' => [
                    'allow_all'  => esc_html__('Allow All', 'eventful-pro-for-elementor'),
                    'strip_all' => esc_html__('Strip All', 'eventful-pro-for-elementor'),
                    'allow_some' => esc_html__('Allow Some', 'eventful-pro-for-elementor'),
                ],
                'default' => 'allow_all',
                'condition' => [
                    'show_content' => 'yes',
                    'content_type!' => 'excerpt',
                ],
            ]
        );
        $widget->add_control(
            'allow_tag_name',
            [
                'label'     => esc_html__('HTML Tags Names', 'eventful-pro-for-elementor'),
                'type'      => \Elementor\Controls_Manager::TEXT,
                'condition' => [
                    'show_content' => 'yes',
                    'strip_tags' => 'allow_some',
                ],
            ]
        );
        $widget->add_control(
            'content_ellipsis',
            [
                'label'     => esc_html__('Ending Excerpt', 'eventful-pro-for-elementor'),
                'type'      => \Elementor\Controls_Manager::TEXT,
                'default'   => '...',
                'condition' => [
                    'show_content' => 'yes',
                    'content_type!' => 'full_content',
                ],
            ]
        );
        $widget->add_control(
            'content_alignment',
            [
                'label' => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .eventful__item .eventful__item__content' => 'text-align: {{VALUE}};',
                ],
                'condition' => [
                    'show_content' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'show_read_more',
            [
                'label' => esc_html__('Read More', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
            ]
        );

        $widget->add_control(
            'read_more_type',
            [
                'label' => esc_html__('Read More Type', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'default' => 'limit_content',
                'options' => [
                    'button'  => esc_html__('Button', 'eventful-pro-for-elementor'),
                    'text_link' => esc_html__('Text Link', 'eventful-pro-for-elementor'),
                ],
                'default' => 'button',
                'condition' => [
                    'show_read_more' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'read_more_text',
            [
                'label' => esc_html__('Read More Text', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'default' => esc_html__('Read More', 'eventful-pro-for-elementor'),
                'condition' => [
                    'show_read_more' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'show_social_share',
            [
                'label' => esc_html__('Social Share', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'default' => 'yes',
                'separator' => 'before',
            ]
        );

        $widget->add_control(
            'social_sharing_media',
            [
                'label' => esc_html__('Sharing Media', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'multiple' => true,
                'label_block' => true,
                'options' => [
                    'facebook' => esc_html__('Facebook', 'eventful-pro-for-elementor'),
                    'twitter' => esc_html__('Twitter', 'eventful-pro-for-elementor'),
                    'linkedIn' => esc_html__('LinkedIn', 'eventful-pro-for-elementor'),
                    'pinterest' => esc_html__('Pinterest', 'eventful-pro-for-elementor'),
                    'email' => esc_html__('Email', 'eventful-pro-for-elementor'),
                    'instagram' => esc_html__('Instagram', 'eventful-pro-for-elementor'),
                    'vk'   => esc_html__('VK', 'eventful-pro-for-elementor'),
                    'digg' => esc_html__('digg', 'eventful-pro-for-elementor'),
                    'tumblr' => esc_html__('Tumblr', 'eventful-pro-for-elementor'),
                    'reddit' => esc_html__('Reddit', 'eventful-pro-for-elementor'),
                    'whatsapp' => esc_html__('WhatsApp', 'eventful-pro-for-elementor'),
                    'pocket' => esc_html__('Pocket', 'eventful-pro-for-elementor'),
                    'xing' => esc_html__('Xing', 'eventful-pro-for-elementor'),
                ],
                'condition' => [
                    'show_social_share' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'social_media_alignment',
            [
                'label' => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::CHOOSE,
                'options' => [
                    'left' => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default' => 'left',
                'selectors' => [
                    '{{WRAPPER}} .eventful__item__socail-share' => 'text-align: {{VALUE}};',
                ],
                'condition' => [
                    'show_social_share' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'show_preloader',
            [
                'label' => esc_html__('Preloader', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->end_controls_section();
    }
}
