<?php

class EFPE_Detailsettings
{
    /**
     * Content Detailsettings Options.
     */
    public static function ppfe_content_detailsettings_options($widget)
    {
        $widget->start_controls_section(
            'section_detailsettings',
            [
                'label'     => esc_html__('Detail Settings', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
			'efpe_page_link_type',
			[
				'label'     => esc_html__( 'Detail Page Link Type', 'eventful-pro-for-elementor' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options'   => [
					'single_page'   => esc_html__( 'Single Page', 'eventful-pro-for-elementor' ),
					'none'          => esc_html__( 'None (no link action)', 'eventful-pro-for-elementor' ),
				],
				'default'   => 'single_page',
			]
		);
        $widget->add_control(
			'efpe_link_target',
			[
				'label'     => esc_html__( 'Target', 'eventful-pro-for-elementor' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options'   => [
					'_self'     => esc_html__( 'Current Tab', 'eventful-pro-for-elementor' ),
					'_blank'    => esc_html__( 'New Tab', 'eventful-pro-for-elementor' ),
					'_parent'   => esc_html__( 'Parent', 'eventful-pro-for-elementor' ),
					'_top'      => esc_html__( 'Top', 'eventful-pro-for-elementor' ),
				],
				'default'   => '_self',
                'condition' => [
                    'efpe_page_link_type' => 'single_page',
                ],
			]
		);

        $widget->add_control(
			'efpe_link_rel',
			[
				'label' 		=> esc_html__( 'Add rel="nofollow" to item links', 'eventful-pro-for-elementor' ),
				'type' 			=> \Elementor\Controls_Manager::SWITCHER,
				'label_on' 		=> esc_html__( 'Show', 'eventful-pro-for-elementor' ),
				'label_off' 	=> esc_html__( 'Hide', 'eventful-pro-for-elementor' ),
				'return_value' 	=> 'yes',
			]
		);

        $widget->end_controls_section();
    }
}