<?php

class EFPE_Layout
{
    /**
     * Content Layout Options.
     */
    public static function ppfe_content_layout_options($widget)
    {
        $widget->start_controls_section(
            'section_layout',
            [
                'label' => esc_html__('Layout', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
            'widget_name',
            [
                'label' => esc_html__('Widget Name', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::HIDDEN,
                'default' => $widget->get_name(),
            ]
        );

        $widget->add_control(
            'content_orientation',
            [
                'label' => esc_html__('Content Orientation', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'default' => esc_html__('Default', 'eventful-pro-for-elementor'),
                    'overlay' => esc_html__('Overlay', 'eventful-pro-for-elementor'),
                ],
                'default' => 'default',
                'condition' => [
                    'widget_name!' => 'eventful-post-list-widget'
                ]
            ]
        );

        $widget->add_control(
            'post_list_orientation',
            [
                'label' => esc_html__('Content Orientation', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => [
                    'left-thumb' => esc_html__('Left Image', 'eventful-pro-for-elementor'),
                    'right-thumb' => esc_html__('Right Image', 'eventful-pro-for-elementor'),
                ],
                'default' => 'left-thumb',
                'condition' => [
                    'widget_name' => 'eventful-post-list-widget'
                ]
            ]
        );
        
        $widget->add_control(
            'efpe_sticky_post',
            [
                'label' => esc_html__('Sticky Post', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options'    => array(
                    'normal_position' => esc_html__( 'Normal Position', 'eventful-pro-for-elementor' ),
                    'top_list'        => esc_html__( 'Top of the List', 'eventful-pro-for-elementor' ),
                    'hide'            => esc_html__( 'Hide Sticky Posts', 'eventful-pro-for-elementor' ),
                ),
                'default' => 'normal_position',
            ]
        );

        $widget->add_control(
            'efpe_include_only_posts',
            [
                'label'         => esc_html__('Include Only', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'label_block'   => true,
                'multiple'      => true,
                'options'       => EFPE_Utilities_Functions::include_only_post(),
            ]
        );
        
        $widget->add_control(
            'efpe_exclude_post_set',
            [
                'label'         => esc_html__('Exclude', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'label_block'   => true,
                'multiple'      => true,
                'separator' => 'before',
                'options'       => EFPE_Utilities_Functions::include_only_post(),
                'conditions' => [
                    'terms' => [
                        [
                            'name' => 'efpe_include_only_posts',
                            'operator' => '==',
                            'value' => '',
                        ],
                    ],
                ],
            ]
        );

        $widget->add_control(
            'efpe_exclude_too',
            [
                'label'         => esc_html__('Exclude post type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'label_block'   => true,
                'multiple'      => true,
                'separator' => 'after',
                'options'       => array(
                    'current'               => esc_html__( 'Current Post', 'eventful-pro-for-elementor' ),
                    'password_protected'    => esc_html__( 'Password Protected Posts', 'eventful-pro-for-elementor' ),
                ),
            ]
        );
         
        $widget->add_control(
            'efpe_event_type',
            [
                'label'         => esc_html__('Type of Event', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => array(
                    'future'    => esc_html__( 'Upcoming Events', 'eventful-pro-for-elementor' ),
                    'past'      => esc_html__( 'Past Events', 'eventful-pro-for-elementor' ),
                    'all'       => esc_html__( 'All (Upcoming + Past)', 'eventful-pro-for-elementor' ),
                ),
                'default' => 'all',
            ]
        );

        $widget->add_control(
            'efpe_post_limit',
            [
                'label'         => esc_html__('Limit', 'eventful-pro-for-elementor'),
                'description'   => esc_html__('Number of total items to display.', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::NUMBER,
                'default'       => 20,
            ]
        );
        $widget->add_control(
            'efpe_post_offset',
            [
                'label'         => esc_html__('Offset', 'eventful-pro-for-elementor'),
                'description'   => esc_html__('Number of total items to display.', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::NUMBER,
                'default'       => 0,
            ]
        );

        $widget->add_control(
            'item_same_height',
            [
                'label'         => esc_html__('Same Height', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->end_controls_section();
    }
}
