<?php
class EFPE_Query
{
    /**
     * Content Query Options.
     */
    public static function ppfe_content_query_options($widget)
    {

        $widget->start_controls_section(
            'section_query',
            [
                'label' => esc_html__('Query', 'eventful-pro-for-elementor'),
                'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
            ]
        );

        $widget->add_control(
            'advanced_filtering',
            [
                'label' => esc_html__('Advanced Filtering', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::HEADING,
                'separator' => 'before',
            ]
        );
        $widget->add_control(
            'efpe_advanced_filter',
            [
                'label' => esc_html__('Filter by', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'description' => esc_html__('Pick options to filter.', 'eventful-pro-for-elementor'),
                'label_block' => true,
                'multiple' => true,
                'options' => [
                    'taxonomy' => esc_html__('Taxonomy', 'eventful-pro-for-elementor'),
                    'author' => esc_html__('Author', 'eventful-pro-for-elementor'),
                    'sortby' => esc_html__('Sort By', 'eventful-pro-for-elementor'),
                    'status' => esc_html__('Status', 'eventful-pro-for-elementor'),
                    'date' => esc_html__('Date', 'eventful-pro-for-elementor'),
                    'keyword' => esc_html__('Keyword', 'eventful-pro-for-elementor'),
                ],
            ]
        );

        $widget->add_control(
            'taxonomy_query_toggle',
            [
                'label' => esc_html__('Taxonomy', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'condition' => [
                    'efpe_advanced_filter' => 'taxonomy',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'taxonomy_options',
            [
                'label' => esc_html__('Taxonomy Options', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::REPEATER,
                'prevent_empty' => false,
                'fields' => [
                    [
                        'name' => 'select_taxonomy',
                        'label' => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor'),
                        'type' => \Elementor\Controls_Manager::SELECT,
                        'options' => array_merge(['' => esc_html__('Select Taxonomy', 'eventful-pro-for-elementor')], EFPE_Utilities_Functions::get_post_type_taxonomies('tribe_events')),
                        'label_block' => true,
                        'default' => 'category'
                    ],

                    [
                        'name' => 'hide_taxonomy_name',
                        'label' => esc_html__('Hide Taxonomy Name', 'eventful-pro-for-elementor'),
                        'type' => \Elementor\Controls_Manager::SWITCHER,
                        'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                        'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                        'default' => 'yes',
                    ],
                    [
                        'name' => 'taxonomy_term_operator',
                        'label' => esc_html__('Operator', 'eventful-pro-for-elementor'),
                        'type' => \Elementor\Controls_Manager::SELECT,
                        'options' => [
                            'IN' => esc_html__('IN', 'eventful-pro-for-elementor'),
                            'AND' => esc_html__('AND', 'eventful-pro-for-elementor'),
                            'NOT IN' => esc_html__('NOT IN', 'eventful-pro-for-elementor'),
                        ],
                        'default' => 'IN',
                    ],
                    [
                        'name' => 'add_filter_post',
                        'label' => esc_html__('Add to Ajax Live Filters', 'eventful-pro-for-elementor'),
                        'type' => \Elementor\Controls_Manager::SWITCHER,
                        'label_on' => esc_html__('Show', 'eventful-pro-for-elementor'),
                        'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
                    ],
                    [
                        'name' => 'ajax_filter_style',
                        'label' => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                        'type' => \Elementor\Controls_Manager::SELECT,
                        'options' => [
                            'fl_dropdown' => esc_html__('Dropdown', 'eventful-pro-for-elementor'),
                            'fl_radio' => esc_html__('Radio', 'eventful-pro-for-elementor'),
                            'fl_checkbox' => esc_html__('Checkbox', 'eventful-pro-for-elementor'),
                            'fl_btn' => esc_html__('Button', 'eventful-pro-for-elementor'),
                        ],
                        'default' => 'fl_btn',
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                    [
                        'name'          => 'ajax_filter_label',
                        'label'         => esc_html__('Live Filter Label', 'eventful-pro-for-elementor'),
                        'type'          => \Elementor\Controls_Manager::TEXT,
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                    [
                        'name'          => 'ajax_rename_all_text',
                        'label'         => esc_html__('Rename "All" Text', 'eventful-pro-for-elementor'),
                        'type'          => \Elementor\Controls_Manager::TEXT,
                        'default'       => esc_html__('All', 'eventful-pro-for-elementor'),
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                    [
                        'name'          => 'ajax_hide_empty',
                        'label'         => esc_html__('Hide Empty Term(s)', 'eventful-pro-for-elementor'),
                        'type'          => \Elementor\Controls_Manager::SWITCHER,
                        'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                        'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                    [
                        'name'          => 'ajax_show_count',
                        'label'         => esc_html__('Show Post Count', 'eventful-pro-for-elementor'),
                        'type'          => \Elementor\Controls_Manager::SWITCHER,
                        'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                        'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                    [
                        'name'          => 'efpe_live_filter_align',
                        'label'         => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                        'type'          => \Elementor\Controls_Manager::CHOOSE,
                        'options'       => [
                            'left' => [
                                'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                                'icon'  => 'eicon-text-align-left',
                            ],
                            'center' => [
                                'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                                'icon'  => 'eicon-text-align-center',
                            ],
                            'right' => [
                                'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                                'icon'  => 'eicon-text-align-right',
                            ],
                        ],
                        'default'       => 'center',
                        'condition'     => [
                            'add_filter_post' => 'yes',
                        ],
                    ],
                ],
            ],

        );

        $widget->add_control(
            'taxonomy_relation',
            [
                'label'         => esc_html__('Relation', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'AND'       => esc_html__('AND', 'eventful-pro-for-elementor'),
                    'OR'        => esc_html__('OR', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'AND',
            ]
        );

        $widget->end_popover();

        $widget->add_control(
            'author_query_toggle',
            [
                'label'         => esc_html__('Author', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'label_off'     => esc_html__('Default', 'eventful-pro-for-elementor'),
                'label_on'      => esc_html__('Custom', 'eventful-pro-for-elementor'),
                'return_value'  => 'yes',
                'default'       => 'yes',
                'condition'     => [
                    'efpe_advanced_filter' => 'author',
                ],
            ]
        );

        $widget->start_popover();


        $widget->add_control(
            'select_author',
            [
                'label'         => esc_html__('Post by Author', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'multiple'      => true,
                'label_block'   => true,
                'options'       => EFPE_Utilities_Functions::get_post_type_author(),
            ]
        );
        $widget->add_control(
            'author_live_filters',
            [
                'label'         => esc_html__('Add to Ajax Live Filters', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );
        $widget->add_control(
            'author_filter_style',
            [
                'label'         => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'fl_dropdown' => esc_html__('Dropdown', 'eventful-pro-for-elementor'),
                    'fl_radio'  => esc_html__('Radio', 'eventful-pro-for-elementor'),
                    'fl_checkbox' => esc_html__('Checkbox', 'eventful-pro-for-elementor'),
                    'fl_btn'    => esc_html__('Button', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'fl_btn',
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'author_filter_label',
            [
                'label' => esc_html__('Live Filter Label', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::TEXT,
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'author_rename_all_text',
            [
                'label'         => esc_html__('Rename "All" Text', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::TEXT,
                'default'       => esc_html__('All', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'author_hide_empty',
            [
                'label'         => esc_html__('Hide Empty Term(s)', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'author_show_count',
            [
                'label'         => esc_html__('Show Post Count', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'author_live_filter_align',
            [
                'label'         => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::CHOOSE,
                'options'       => [
                    'left'      => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-left',
                    ],
                    'center'    => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-right',
                    ],
                ],
                'default'       => 'center',
                'condition'     => [
                    'author_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'select_not_author',
            [
                'label'         => esc_html__('Post Not by Author', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'multiple'      => true,
                'label_block'   => true,
                'options'       => EFPE_Utilities_Functions::get_post_type_author(),
            ]
        );
        $widget->end_popover();

        $widget->add_control(
            'sortby_query_toggle',
            [
                'label'         => esc_html__('Order By', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'label_off'     => esc_html__('Default', 'eventful-pro-for-elementor'),
                'label_on'      => esc_html__('Custom', 'eventful-pro-for-elementor'),
                'return_value'  => 'yes',
                'default'       => 'yes',
                'condition'     => [
                    'efpe_advanced_filter' => 'sortby',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'select_sortby',
            [
                'label' => esc_html__('Post by Author', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'multiple' => true,
                'label_block' => true,
                'options' => array(
                    'ID'           => esc_html__('ID', 'eventful-pro-for-elementor'),
                    'title'        => esc_html__('Title', 'eventful-pro-for-elementor'),
                    '_EventStartDate'         => esc_html__('Event Start Date', 'eventful-pro-for-elementor'),
                    'date'         => esc_html__('Date', 'eventful-pro-for-elementor'),
                    'modified'     => esc_html__('Modified date', 'eventful-pro-for-elementor'),
                    'post__in'     => esc_html__('Post in (Drag & Drop)', 'eventful-pro-for-elementor'),
                    'post_slug'    => esc_html__('Post slug', 'eventful-pro-for-elementor'),
                    'post_type'    => esc_html__('Post type', 'eventful-pro-for-elementor'),
                    'rand'         => esc_html__('Random', 'eventful-pro-for-elementor'),
                    'comment_count' => esc_html__('Comment count', 'eventful-pro-for-elementor'),
                    'menu_order'   => esc_html__('Menu order', 'eventful-pro-for-elementor'),
                    'author'       => esc_html__('Author', 'eventful-pro-for-elementor'),
                    'most_liked'   => esc_html__('Most Liked', 'eventful-pro-for-elementor'),
                    'most_viewed'  => esc_html__('Most Viewed', 'eventful-pro-for-elementor'),
                ),
                'default' => '_EventStartDate',
            ]
        );
        $widget->add_control(
            'sortby_live_filters',
            [
                'label'     => esc_html__('Add to Ajax Live Filters', 'eventful-pro-for-elementor'),
                'type'      => \Elementor\Controls_Manager::SWITCHER,
                'label_on'  => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off' => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
            'sortby_filter_style',
            [
                'label'         => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => [
                    'fl_dropdown'   => esc_html__('Dropdown', 'eventful-pro-for-elementor'),
                    'fl_radio'      => esc_html__('Radio', 'eventful-pro-for-elementor'),
                    'fl_checkbox'   => esc_html__('Checkbox', 'eventful-pro-for-elementor'),
                    'fl_btn'        => esc_html__('Button', 'eventful-pro-for-elementor'),
                ],
                'default'       => 'fl_btn',
                'condition'     => [
                    'sortby_live_filters' => 'yes',
                ],
            ]
        );
        $widget->add_control(
            'efpe_add_filter_orderby',
            [
                'label'         => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT2,
                'multiple'      => true,
                'label_block'   => true,
                'options'       => array(
                    'ID'            => esc_html__( 'ID', 'eventful-pro-for-elementor' ),
                    'title'         => esc_html__( 'Title', 'eventful-pro-for-elementor' ),
                    '_EventStartDate'          => esc_html__( 'Event Start Date', 'eventful-pro-for-elementor' ),
                    'date'          => esc_html__( 'Date', 'eventful-pro-for-elementor' ),
                    'modified'      => esc_html__( 'Modified date', 'eventful-pro-for-elementor' ),
                    'post_type'     => esc_html__( 'Post type', 'eventful-pro-for-elementor' ),
                    'rand'          => esc_html__( 'Random', 'eventful-pro-for-elementor' ),
                    'comment_count' => esc_html__( 'Comment count', 'eventful-pro-for-elementor' ),
                    'menu_order'    => esc_html__( 'Menu order', 'eventful-pro-for-elementor' ),
                    'author'        => esc_html__( 'Author', 'eventful-pro-for-elementor' ),
                    'most_liked'    => esc_html__( 'Most Liked', 'eventful-pro-for-elementor' ),
                    'most_viewed'   => esc_html__( 'Most Viewed', 'eventful-pro-for-elementor' ),
                ),
                'condition'         => [
                    'sortby_live_filters' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'sortby_filter_label',
            [
                'label'         => esc_html__('Label', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::TEXT,
                'condition'     => [
                    'sortby_live_filters' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'sortby_live_filter_align',
            [
                'label'         => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::CHOOSE,
                'options'       => [
                    'left'      => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-left',
                    ],
                    'center'    => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-center',
                    ],
                    'right'     => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-right',
                    ],
                ],
                'default'       => 'center',
                'condition'     => [
                    'sortby_live_filters' => 'yes',
                ],
            ]
        );
        
        $widget->add_control(
            'select_filter_order',
            [
                'label'         => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => array(
                    'ASC'       => esc_html__( 'Ascending', 'eventful-pro-for-elementor' ),
                    'DESC'      => esc_html__( 'Descending', 'eventful-pro-for-elementor' ),
                ),
                'default'       => 'ASC',
                'condition'     => [
                    'sortby_live_filters' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'add_order_filter_post',
            [
                'label'         => esc_html__('Add to Ajax Live Filters', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SWITCHER,
                'label_on'      => esc_html__('Show', 'eventful-pro-for-elementor'),
                'label_off'     => esc_html__('Hide', 'eventful-pro-for-elementor'),
            ]
        );

        $widget->add_control(
            'order_filter_options',
            [
                'label'         => esc_html__('Filter Type', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::SELECT,
                'options'       => array(
                    'fl_dropdown' => esc_html__( 'Dropdown', 'eventful-pro-for-elementor' ),
                    'fl_radio'    => esc_html__( 'Radio', 'eventful-pro-for-elementor' ),
                    'fl_btn'      => esc_html__( 'Button', 'eventful-pro-for-elementor' ),
                ),
                'default' => 'fl_dropdown',
                'condition'     => [
                    'add_order_filter_post' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'order_filter_label',
            [
                'label'         => esc_html__('Label', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::TEXT,
                'default'       => esc_html('Order', 'eventful-pro-for-elementor'),
                'condition'     => [
                    'add_order_filter_post' => 'yes',
                ],
            ]
        );

        $widget->add_control(
            'efpe_live_filter_align',
            [
                'label'         => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::CHOOSE,
                'options'       => [
                    'left'      => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon'  => 'eicon-text-align-right',
                    ],
                ],
                'default'       => 'center',
                'condition'     => [
                    'add_order_filter_post' => 'yes',
                ],
            ]
        );

        $widget->end_popover();

        $widget->add_control(
            'status_query_toggle',
            [
                'label'         => esc_html__('Post Status', 'eventful-pro-for-elementor'),
                'type'          => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'label_off'     => esc_html__('Default', 'eventful-pro-for-elementor'),
                'label_on'      => esc_html__('Custom', 'eventful-pro-for-elementor'),
                'return_value'  => 'yes',
                'default'       => 'yes',
                'condition'     => [
                    'efpe_advanced_filter' => 'status',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'select_status',
            [
                'label' => esc_html__('Post Status', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT2,
                'multiple' => true,
                'label_block' => true,
                'options' => EFPE_Utilities_Functions::get_post_statuses(),
            ]
        );
        $widget->end_popover();
        $widget->add_control(
            'date_query_toggle',
            [
                'label' => esc_html__('Date', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'label_off' => esc_html__('Default', 'eventful-pro-for-elementor'),
                'label_on' => esc_html__('Custom', 'eventful-pro-for-elementor'),
                'return_value' => 'yes',
                'default' => 'yes',
                'condition'     => [
                    'efpe_advanced_filter' => 'date',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
            'select_date',
            [
                'label' => esc_html__('Published Date', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options' => array(
                    'yesterday'  => esc_html__('Yesterday', 'eventful-pro-for-elementor'),
                    'today_only' => esc_html__('Today Only', 'eventful-pro-for-elementor'),
                    'today_onwards' => esc_html__('Today and Onwards', 'eventful-pro-for-elementor'),
                    'this_week'  => esc_html__('This Week', 'eventful-pro-for-elementor'),
                    'this_month' => esc_html__('This Month', 'eventful-pro-for-elementor'),
                    'this_year'  => esc_html__('This Year', 'eventful-pro-for-elementor'),
                    'week_ago'   => esc_html__('1 Week ago to today', 'eventful-pro-for-elementor'),
                    'month_ago'  => esc_html__('1 month ago to today', 'eventful-pro-for-elementor'),
                    'year_ago'   => esc_html__('1 year ago to today', 'eventful-pro-for-elementor'),
                    'specific_date' => esc_html__('Specific Date', 'eventful-pro-for-elementor'),
                    'specific_month' => esc_html__('Specific Month', 'eventful-pro-for-elementor'),
                    'specific_year' => esc_html__('Specific Year', 'eventful-pro-for-elementor'),
                    'specific_period' => esc_html__('Specific Period ( From & To )', 'eventful-pro-for-elementor'),
                ),
            ]
        );
        $widget->add_control(
            'select_post_specific_date',
            [
                'label' => esc_html__('Select Date', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::DATE_TIME,
                'label_block'   => false,
                'condition'     => [
                    'select_date' => 'specific_date',
                ],
                'default'   => 'yy-mm-dd',
            ]
        );
        $widget->add_control(
            'select_post_date_from',
            [
                'label' => esc_html__('From', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::DATE_TIME,
                'label_block'   => false,
                'condition'     => [
                    'select_date' => 'specific_period',
                ],
                'default'   => 'yy-mm-dd',
            ]
        );
        $widget->add_control(
            'select_post_date_to',
            [
                'label' => esc_html__('To', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::DATE_TIME,
                'label_block'   => false,
                'condition'     => [
                    'select_date' => 'specific_period',
                ],
                'default'   => 'yy-mm-dd',
            ]
        );
        $widget->add_control(
            'select_specific_month',
            [
                'label' => esc_html__('Published Date', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::SELECT,
                'options'    => array(
                    '1'  => esc_html__('January', 'eventful-pro-for-elementor'),
                    '2'  => esc_html__('February', 'eventful-pro-for-elementor'),
                    '3'  => esc_html__('March', 'eventful-pro-for-elementor'),
                    '4'  => esc_html__('April', 'eventful-pro-for-elementor'),
                    '5'  => esc_html__('May', 'eventful-pro-for-elementor'),
                    '6'  => esc_html__('June', 'eventful-pro-for-elementor'),
                    '7'  => esc_html__('July', 'eventful-pro-for-elementor'),
                    '8'  => esc_html__('August', 'eventful-pro-for-elementor'),
                    '9'  => esc_html__('September', 'eventful-pro-for-elementor'),
                    '10' => esc_html__('October', 'eventful-pro-for-elementor'),
                    '11' => esc_html__('November', 'eventful-pro-for-elementor'),
                    '12' => esc_html__('December', 'eventful-pro-for-elementor'),
                ),
                'condition'     => [
                    'select_date' => 'specific_month',
                ],
            ]
        );

        $widget->add_control(
            'select_post_specific_year',
            [
                'label' => esc_html__('Set Year', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::NUMBER,
                'default' => 2024,
                'condition'     => [
                    'select_date' => 'specific_year',
                ],
            ]
        );
        $widget->end_popover();
        $widget->add_control(
            'keyword_query_toggle',
            [
                'label' => esc_html__('Type Keyword', 'eventful-pro-for-elementor'),
                'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
                'label_off' => esc_html__('Default', 'eventful-pro-for-elementor'),
                'label_on' => esc_html__('Custom', 'eventful-pro-for-elementor'),
                'return_value' => 'yes',
                'default' => 'yes',
                'condition'     => [
                    'efpe_advanced_filter' => 'keyword',
                ],
            ]
        );

        $widget->start_popover();

        $widget->add_control(
			'efpe_set_post_keyword',
			[
				'label' => esc_html__( 'Type Keyword', 'eventful-pro-for-elementor' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'placeholder' => esc_html__( 'Enter keyword(s).', 'eventful-pro-for-elementor' ),
			]
		);

        $widget->add_control(
			'add_search_filter_post',
			[
				'label' => esc_html__( 'Add to Ajax Live Filters', 'eventful-pro-for-elementor' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'eventful-pro-for-elementor' ),
				'label_off' => esc_html__( 'Hide', 'eventful-pro-for-elementor' ),
				'return_value' => 'yes',
			]
		);

        $widget->add_control(
			'keyword_filter_label',
			[
				'label'         => esc_html__( 'Label', 'eventful-pro-for-elementor' ),
				'type'          => \Elementor\Controls_Manager::TEXT,
				'placeholder'   => esc_html__( 'Type live filter label.', 'eventful-pro-for-elementor' ),
                'condition'     => [
                    'add_search_filter_post' => 'yes',
                ],
			]
		);

        $widget->add_control(
            'keyword_live_filter_align',
            [
                'label'     => esc_html__('Alignment', 'eventful-pro-for-elementor'),
                'type'      => \Elementor\Controls_Manager::CHOOSE,
                'options'   => [
                    'left'  => [
                        'title' => esc_html__('Left', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-left',
                    ],
                    'center' => [
                        'title' => esc_html__('Center', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-center',
                    ],
                    'right' => [
                        'title' => esc_html__('Right', 'eventful-pro-for-elementor'),
                        'icon' => 'eicon-text-align-right',
                    ],
                ],
                'default'   => 'center',
                'condition'     => [
                    'add_search_filter_post' => 'yes',
                ],
            ]
        );
        
        $widget->end_popover();

        $widget->end_controls_section();
    }
}
